<script setup lang="ts">
import { ref } from "vue";

let cards = ref([
  {
    id: 0,
    title: `I am vue element`,
  },
  {
    id: 1,
    title: `I am vue element`,
  },
  {
    id: 2,
    title: `I am vue element`,
  },
]);

const addItemInLoop = async () => {
  if (cards.value.length >= 8) {
    return;
  }

  cards.value = [
    ...cards.value.map((x) => ({ id: x.id, title: `I am vue element updated` })),
    {
      id: cards.value.length,
      title: `I am vue element`,
    },
  ];

  setTimeout(() => {
    addItemInLoop();
  }, 1000);
};

setTimeout(() => {
  addItemInLoop();
}, 1000);

const srcImg = "./assets/vue.png";
</script>

<template>
  <div class="flex">
    <span class="flex flex-col bordered padded" v-for="card in cards" :key="card.id">
      <h2>{{ card.title }}</h2>
      <img width="100" height="100" alt="vue-logo" :src="srcImg" />
    </span>
  </div>
</template>

<style>
body {
  background: white;
}

h2 {
  margin: 0;
}

.flex {
  display: flex;
  row-gap: 10px;
  column-gap: 10px;
  flex-wrap: wrap;
}

.flex-row {
  flex-flow: row;
  column-gap: 10px;
  flex-wrap: wrap;
}

.flex-col {
  flex-flow: column;
  row-gap: 5px;
  min-width: 140px;
  width: 140px;

  justify-content: center;
  align-items: center;
}

.padded {
  padding: 5px;
}

.bordered {
  border: 1px solid #a0a0a0;
  border-radius: 5px;
}
</style>
